<script setup lang="ts">
    import { SearchEntity } from '@/interventionServiceOffer/entities/searchEntity/SearchEntity'
    import { SearchEntityAPi } from '@/interventionServiceOffer/entities/searchEntity/SearchEntityApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import { isDefined, isNull, requiredInject } from '@/shared/helpers/types'
    import { computed, ref, watch } from 'vue'
    import SDialog from '../global/SDialog.vue'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import {
        itemIcons,
        ItemLists,
    } from '@/interventionServiceOffer/composables/equipement/useItemLists'
    import { SilabError } from '@/shared/errors/SilabError'
    import { LoadingManager } from '@/shared/helpers/lifeCycle'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'

    const emit = defineEmits<{
        (e: 'selectItem', itemType: keyof ItemLists, itemId: string): void
    }>()

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const msal = useMsal()
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )

    const searchEntityApi = new SearchEntityAPi(msal)
    const searchEntityFetchAborter = new RequestAborter()

    const searchEntityQuery = ref<string | null>(null)
    const searchEntitiesResults = ref<SearchEntity[]>([])

    const displaySearchDialog = ref(false)
    const entitySearchLoadingManager = new LoadingManager()

    const updateSearchEntityTimeout = ref<undefined | number>(undefined)

    watch(searchEntityQuery, () => {
        annulerRecherche()
        window.clearTimeout(updateSearchEntityTimeout.value)
        updateSearchEntityTimeout.value = undefined
        if (searchEntityQuery.value === '' || isNull(searchEntityQuery.value)) {
            return
        }
        updateSearchEntityTimeout.value = window.setTimeout(() => {
            rechercher()
            updateSearchEntityTimeout.value = undefined
        }, 500)
    })

    const etatDeLaRechercheDEntite = computed<
        'rien à chercher' | 'recherche en cours' | 'recherche terminée'
    >(() => {
        if (
            entitySearchLoadingManager.isLoading.value ||
            isDefined(updateSearchEntityTimeout.value)
        ) {
            return 'recherche en cours'
        }
        if (searchEntityQuery.value === '' || isNull(searchEntityQuery.value)) {
            return 'rien à chercher'
        }
        return 'recherche terminée'
    })

    async function rechercher() {
        if (isNull(searchEntityQuery.value)) {
            return
        }
        const stopLoading = entitySearchLoadingManager.startLoading()

        searchEntityApi
            .search(
                serviceOfferId.value,
                searchEntityQuery.value,
                searchEntityFetchAborter.getSignal()
            )
            .then((fetchedSearchEntity) => {
                searchEntitiesResults.value = fetchedSearchEntity
            })
            .catch((error) => {
                if (error.name !== 'AbortError') {
                    throw new SilabError((<Error>error).message, 'error')
                }
            })
            .finally(() => {
                stopLoading()
            })
    }

    function annulerRecherche() {
        searchEntitiesResults.value = []
        searchEntityFetchAborter.abortRequestsAndRefreshAborter()
    }

    function selectSearchEntityAndCloseSearchDialog(
        selectedSearchEntity: SearchEntity
    ) {
        getAnalyticsProvider().sendEvent(
            serviceOfferTrackingCategory.value,
            'Selection via recherche',
            `recherche de ${selectedSearchEntity.type}`
        )
        emit('selectItem', selectedSearchEntity.type, selectedSearchEntity.id)
        displaySearchDialog.value = false
    }
</script>

<template>
    <v-btn
        icon="mdi-magnify"
        color="on-background"
        @click="displaySearchDialog = true"
    />
    <s-dialog
        v-model="displaySearchDialog"
        title="Rechercher un équipement, une demande ou une intervention"
        :display-close-button="true"
        @close-dialog="displaySearchDialog = false"
    >
        <v-text-field
            v-model="searchEntityQuery"
            label="Code ou nom de l'élément"
            clearable
            autofocus
            @click:clear="annulerRecherche()"
        />

        <v-list>
            <v-list-item
                v-for="entity in searchEntitiesResults"
                :key="entity.id"
                :prepend-icon="itemIcons[entity.type]"
                :title="entity.label"
                :subtitle="entity.code"
                @click="selectSearchEntityAndCloseSearchDialog(entity)"
            />
        </v-list>

        <p
            v-if="
                etatDeLaRechercheDEntite === 'recherche terminée' &&
                searchEntitiesResults.length === 0
            "
        >
            Il n'y a aucun resultat
        </p>

        <v-skeleton-loader
            v-if="etatDeLaRechercheDEntite === 'recherche en cours'"
            type="list-item-two-line"
        />
    </s-dialog>
</template>
